## History

The clrmame project started in 1997. The first release was a commandline based MS-DOS application. If you now think that it was the first auditing program I have to say: no, you're wrong. There was a tiny little tool (damn..I don't remember its name) which wasn't very powerful but was the first attemp to check your filecollections. I found it not very useful and was frustrated by cleaning filesets by hand at that time. So I decided to write my own utility. clrmame was written in C and was compiled with the GNU compiler. 1997 I changed it to a Windows GUI based program called clrmame For Windows. And finally 1998 clrmamepro was born and looks to be the most powerful ROM- Manager around. clrmamepro is written in C++ and is currently compiled with MS VS2005 SP1.

Here is a list of the latest changes to clrmamepro:

clrmamepro 3.108b

- misc: removing parent/clone relationships for sets which got nodump roms in one and valid dumps (for the same roms) in a clone/parent set. Prevents from overwriting each other when merging.
- fixed: showing wrong (clone) color for removed parent/clone relationship sets in setinformation tree
- fixed: memory leak when leaving with "The program is already running!" message
- fixed: rare crash in system->auto detect sysdef paths

clrmamepro 3.108a

- misc: nodump handling is now locked to 'hide missing', disabled 'create missing' and enabled 'mark no dumps as unneeded'.

clrmamepro 3.108

- added: split rar support ("remove rebuilt source files" removes only first part though")

clrmamepro 3.107b

- fixed: biosset assignment routine assigned some wrong biossets (CVS) in MAME .121u3.

clrmamepro 3.107a

- misc: systems and setinfo window got max/min boxes
- misc: memory usage for no recompress is limited to max 1GB (also in auto mode)
- misc: settings->unneeded masks can be added by drag'n drop
- misc: updated unrar.dll
- fixed: search folder for crc32 was partially broken
- fixed: about drag'n drop size information was wrong for files (not archives)

clrmamepro 3.107

- misc: changed WindowToFront method which doesn't falsely stick the window as topmost sometimes
- misc: showing warning about crc32= 1/-1
- misc: removed a typo in dir2dat tooltip
- misc: added a n64 header xml description (thanks Cue)
- misc: www profiler xml creator allows optional subfolder scanning
- misc: Linux WINE/Mac Crossover users: adding a cmpro.ini setting "Adv_HideWindow = off" helps you when you got issues with the showing/hiding of the 6 button bar

clrmamepro 3.106c

- fixed: fullmerged 'create missing nodump' sometimes selected clone folder

clrmamepro 3.106b

- fixed: fix-missing-rom for full merged sets didn't work correctly
- fixed: uncompressed clones scan was broken

clrmamepro 3.106a

- misc: several updates to the window rendering system (incl. not stealing focus correct minimizing, warnings window only shows issues, etc.)
- misc: allowing not existent sampleparents (invaders)

clrmamepro 3.106

- misc: Linux WINE: changed systime convertion to work flawlessly (www profiler)
- misc: Linux WINE: launch button bar isn't hidden anymore (but minimized). This increases compatibility and even fixes some MS Windows issues.
- misc: Linux WINE: changed warnings window. It will now automatically appear if something appears in it. You can still minimize it then.
- misc: several windows correctly appear at the front now.
- misc: treectrl and listctrl bitmaps are now 24bit and different
- misc: F2 (edit label) functionality to several list and tree controls
- misc: listing corrupt containes (corrupt chds, zips...) in the stats
- misc: disabled "Possible missing alternative samples folder" in the database checker MAME doesn't load samples from a parentset when no sampleof tag is given. In consequence you may need some more samplesets for MAME now.

clrmamepro 3.105a

- misc: not using MoveWindow(..., redraw=false) anymore since it causes some artefacts on some gfx drivers

clrmamepro 3.105

- added: rebuilder advanced option "skip source folder after x skipped files". This skips files in the current rebuilder source path list when a given number of files were skipped.
- added: added above option to batcher as well
- added: support for ctrl-a (select all) and ctrl-i (invert selection) in profiler dat list (remember to keep ctrl pressed when you then right-click)
- added: rebuilder advanced option for auto memory selection for no recompress
- misc: sizeable windows got some min x/y values now
- misc: 'fix missing' and 'create missing nodump' don't select a chdfolder to add the found missing files
- misc: speed optimized even/odd split (checksum analysis)
- misc: running even/odd split only when found file is twice as big as the rom
- misc: removed 'fix size' sliding crc32 window and only check head/tail of file
- misc: changed way of showing/hiding main window
- misc: changed way of showing the profiler on startup
- fixed: wrong window title is shown when saving a have-list
- fixed: profiler shows a list icon in the tree after adding/downloading a dat

clrmamepro 3.104c

- fixed: moved chds aren't found directly but in 2nd scan
- fixed: nodump bios files isn't handled separately (no green profile if you don't have MAME's mac2bios)
- misc: increased max value for no-recompress buffer to 1GB
- added: batcher option to auto-delete fixdats when empty

clrmamepro 3.104b

- fixed: empty fix case setname prompt for some non existing parents
- misc: set+case check also checks chd subfolder names now

clrmamepro 3.104a

- fixed: systems->auto detect sys default paths crashes
- fixed: full merged fake clones which only differ in a chd (code1db) are falsely shown as missing
- fixed: download name doesn't change when downloading multiple files

clrmamepro 3.104

- fixed: clone chds in full merged mode weren't found in 3.103b
- misc: changed default value for "deeper check for fixable missing files"

clrmamepro 3.103b (20-August-2007)

- misc: some scanning speed increase (no yoshi, not related to your post but related to another analysing step which minimizes disk access)

clrmamepro 3.103a (14-August-2007)

- added: rebuild download folder after download option (popup menu www open)
- fixed: baddump biosrom export is broken
- fixed: some nodump biosroms weren't marked as biosrom

clrmamepro 3.103 (26-July-2007)

- added: download (current set/current parent/all listed) functionality
- misc: replaced biosset hacks with full support for new MAME biossystem
- fixed: exception in direct mame import (when using bad exe files)
- fixed: rare issue when profiler tree icons become a profile list icon

clrmamepro 3.102c (19-July-2007)

- added: support for upcoming new biosset detection
- misc: workaround for MAME .117u1 biosset issue

clrmamepro 3.102b (09-July-2007)

- misc: changed the unneeded/wrong placed chd routines a bit
- fixed: crash while doing a full integrity on a corrupt chd
- fixed: drag'n drop in profiler www mode fails when using a non www ini file

clrmamepro 3.102a (14-June-2007)

- fixed: 7zip support got accidently broken in 3.102

clrmamepro 3.102 (12-June-2007)

- added: rebuilder option to show/hide rebuilder stats
- added: www site attributes can now be changed anytime
- misc: optimized speed of byteorder fix-checksum check immensly
- misc: replaced beep() with MessageBeep to work correctly under Vista

clrmamepro 3.101a (15-May-2007)

- fixed: file size detection for header files (rar, 7z and uncompressed only)

clrmamepro 3.101 (08-May-2007)

- fixed: some wrong fixing messages when sets are shared
- misc: fix datfiles, set export etc include chds and samples

clrmamepro 3.100c (19-Apr-2007)

- fixed: wrong 'wrong placed chd' messages for removed parent/clone relationship sets
- misc: minor changes for Vista and 64bit build

clrmamepro 3.100b (09-Apr-2007)

- fixed: wrong 'wrong case' message when using setsubfolders

clrmamepro 3.100a (09-Apr-2007)

- misc: changed red/green profile behaviour for complete nodump / biosrom sets

clrmamepro 3.100 (06-Apr-2007)

- added: datfile header entry 'header', specifying the dat needs a special header xml to work correctly. For example "header nes.xml".
- misc: sets which only consists of biosroms AND nodumps aren't shown as missing sets when nodump handling is set to hide AND allow not separated biossets is disabled.
- misc: sets with sharing errors appear grey
- fixed: file sharing errors aren't listed anymore
- fixed: bios sets falsely appear as missing when 'show all missing sets' is disabled
- fixed: nodump handling options gets falsely disabled if datfile only holds nodump chds

clrmamepro 3.99c (28-Mar-2007)

- added: set/chd + fix unneeded check will automatically move wrong placed chds
- added: batcher: created rompath naming is now independent from logfile/fastscan/etc naming
- misc: 'deeper check for fixable missing files' now supports chds, too (although fix-missing for chds isn't in yet)
- misc: checksum analysis steps are shown in the windows title + some better taskswitching
- misc: sets which only consists of biosroms and/or nodumps aren't shown as missing sets when
  nodump handling is set to hide and/or allow not separated biossets is disabled.
- fixed: date/time fix crashes on decompressed sets
- fixed: scan tree and nodump buttons don't get refreshed correctly after scanner advanced
- fixed: batcher: profile status isn't updated when batch run was stopped
- fixed: batcher: scan run is still performed even when batch rebuild run was stopped
- fixed: NSIS installer got some weird issues under MS Vista

clrmamepro 3.99b (08-Mar-2007)

- added: setinfo option to enable sets by setnames in an external file
- fixed: merger was broken when working on compressed files

clrmamepro 3.99a (05-Mar-2007)

- fixed: unneeded chds won't be displayed twice (by CHD and ROM check)
- fixed: gray/green/red profiles isn't updated in all cases
- fixed: wwwprofiler version old/new detector failed on 0.111u6 0.112 change
- fixed: set check for chd-only sets failed when chd rompath-root storing method was used
- fixed: loading of forcezipping dat header information doesn't work
- fixed: nodump chds can get falsely marked as wrong named
- misc: setinfo lists nodumps with "-" now instead of 0
- misc: several internal changes....resulting in some smaller memory usage
- added: 'logical not' checkbox for set selection to invert selection permanently

clrmamepro 3.99 (25-Jan-2007)

- added: added support for nodump chds
- added: pack option for wwwprofile xml creator
- misc: major cleanup for generic packer routines (e.g. scanner is able to scan 7z and rar now)
- misc: scanner nodump handling works now for roms/chds & unpacked sets
- misc: several other internal cleanups and fixes

clrmamepro 3.98 (11-Jan-2007)

- fixed: rare crash when folder browser opens
- misc: added some 7z return codes
- misc: progress window remembers position
- misc: readded profile info in the window title for now

clrmamepro 3.97c (09-Jan-2007)

- fixed: one typo and another issue with the chd relationships

clrmamepro 3.97b (08-Jan-2007)

- misc: setinfo select tree doesn't expand it automatically anymore
- misc: adjusted the www profiler version algorithm a little bit
- misc: moved window title information about loaded profile, set count to tooltips (when hovering over the title bar)
- misc: full archive is also removed by rebuilder-remove-rebuilt-source when it only contains folder entries
- misc: installer uses lzma and remembers an old install dir correctly
- misc: several text changes (mainly diskimage to CHD, zip to compress(or))
- misc: compiled with MS VS 2005 SP1
- fixed: "clone got chds while parent doesn't" "Set-ZipFile AND Set-Folder exist" issue
- fixed: cancel button doesn't work when being hit while refreshing www profiler

clrmamepro 3.97a (21-Dec-2006)

- Made the packer classes more generic, automatically adding rar/7z support to:
  - about: drag'n drop info lists rar/7z & search crc in folder supports rar/7z
  - profiler: online xmlfile can be compressed and xmlfile creator scans rar/7z
  - profiler: datfiles can be compressed to rar/7z
  - dir2dat: reading rar/7z while building the dat
- Scanner, Rebuilder and Merger automatically supports them too now but I need some more time to fully enable it there. Of course you still got the rar/7z support for rebuilder source.
- misc: improved speed of chd scanning
- misc: folder browser takes parent folder if init folder doesn't exist anymore
- misc: some cleanup
- fixed: wrong dupe complain for full merged sets where only clones have chds
- fixed: no grey profile when you download and directly replace the old one

clrmamepro 3.96 (27-Nov-2006)

- added: support for split chds (new feature since MAME .110u3)
- misc: simplified chd decompression checks on fastscan
- misc: chds from inactive sets don't get marked as unneeded anymore
- misc: "move to" message in wrong placed chd info is now always shown
- fixed: enabled headers don't get reset by "clear cache"

clrmamepro 3.95c (20-Nov-2006)

- added: profiler popupmenu option to select profiles by regular expressions
- misc: made the setinformation button a little bit bigger
- misc: next/prev set in setinfo view jumps to the next 'active'
- fixed: falsely show different-task-locked unneeded set as misplaced chd
- fixed: bad zips aren't listed in the warnings window (set name check only)

clrmamepro 3.95b (13-Nov-2006)

- added: separated disk 'merge tag' handling from rom merge tag handling in profiler options window. The default value is 'enabled', so you don't have to double the konami80 chd anymore (and the upcoming DDR ones).
- added: create folder button for small profiler folder selection window
- added: 7z/rar support for About's drag'n drop feature
- added: 7z/rar support for About's Search CRC32 in Folder feature
- misc: garbage collection file list only appears when files were found
- fixed: not fixed wrong named disks falsely reappear as unneeded disks
- fixed: fix wrong size fails for write protected files / archived files
- fixed: batchrun fails for multiple exe based profiles

clrmamepro 3.95a (08-Nov-2006)

- fixed: placement of diskimage checks was wrong for full merged sets
- fixed: total biosrom count and missing diskimage count is wrong
- misc: garbage collection lists 'to be removed' files

clrmamepro 3.95 (07-Nov-2006)

- added: support for diskimage 'merge' tags. This is also handled by the profiler option 'parse merge tags'. In case you don't use it (which is the prefered method imo, you probably have to double identical but differently named chds (currently only MAME109u5 konam80s/j sets are affected).
- added: dir2dat option to handle archives as files (instead of parsing them)
- misc: scanner diskimage routines rewrite
- misc: profiler doesn't need a rescan when running in batchmode
- misc: profiler remembers selected tree/list items in all_profiles mode
- fixed: rom/chd hashlist doesn't get updated on set selection change and direct rescan
- fixed: an unneeded chd doesn't get recognized when rom zipfile exists in the same rompath
- fixed: setinformation tree item checkboxes get enabled on click/init

clrmamepro 3.94c (25-Oct-2006)

- fixed: rebuilder counts 7z/rar files twice
- fixed: rare exception in 7z reader
- fixed: html report puts root datfiles in the last sub folder. Removed the sorting for now since it causes too much trouble
- fixed: www profiler pressing cancel in "selected download folder" still downloads file
- fixed: profiler batchrun lists new profile as grey even when they were just scanned

clrmamepro 3.94b (19-Oct-2006)

- fixed: 3.94a broke the zip rebuilder...doh..not my day today

clrmamepro 3.94a (19-Oct-2006)

- fixed: rebuilding not archived files is broken

clrmamepro 3.94 (19-Oct-2006)

- added: 7z and RAR support (preliminary)
  Currently only for rebuilder source files (no remove-rebuilt-source).
  Standard and solid LZMA 7z archives are supported but not split archives.
  Standard and solid RAR archives are supported but not split archives.
  Before you ask:
  ===============
  No, currently I don't plan to add any compress-related support.
  Be warned:
  ==========
  Rebuilding (solid) RAR and 7z archives with lots of included files is
  currently very slow. Since the Rebuilder is a file based operator, files
  are accessed randomly and such a random access takes long (because to
  work on the file, possible previously stored files in the archive have
  to be taken into account, too).
  Guess you now see the advantages of the ZIP format. I may think about a
  way of optimizing this, but don't count on it.
- added: profiler 'reset profile' which resets the profile to 'new/not loaded' state
- misc: replaced some batchrun checkboxes with radiobuttons
- fixed: single-dat batchrun sometimes still used a previous multi-select
- fixed: dir2dat cancel button reacts sluggish
- fixed: rebuilder's additional check md5/sha1 failed on zip subfolders
- fixed: rebuilder's logfile used internal subfolder syntax instead of "\"

clrmamepro 3.93a (13-Oct-2006)

- fixed: export sets to file falsely converts \r\n to \r\r\n
- fixed: single-click add for path Change doesn't work
- fixed: rebuilder falsely runs the quick size check when ignore-size is enabled
- fixed: rebuilder fix from 3.93 isn't working correctly in all cases

clrmamepro 3.93 (10-Oct-2006)

- added: html report generator for currently selected profiles
- added: fixdat save option to save fixdat for currently selected set
- fixed: rebuilder didn't delete subfolders in cmpro's temp folder
- fixed: setinfo.xml falsely converted "\" to "`"
- fixed: some profiler menus were accessable when they should be disabled
- fixed: folder html report falsely exports the last used folder in <all profiles> mode
- fixed: misplaced remove button in settings
- misc: reorganized profiler's html reports menus
- misc: reorganized scanner's fix dat menus
- misc: minor order changes in scanner's view menu
- misc: setformat.xml can use variables %U/%u for selected urls.ini URL/URLExtension values also added information about all possible vars to setformat.xml
- misc: selected treeitem in set information moves to top when necessary
- misc: improved xml parser's comment handling
- misc: increased the size of set information button ;)
- misc: check for update is not only done on startup but while running, too

clrmamepro 3.92a (08-Oct-2006)

- fixed: sorted html report rarely created a bad html

clrmamepro 3.92 (05-Oct-2006)

- misc: xml parser speed up
- misc: several gui changes ('export' moved to 'sets', thread prio moved to zipsettings)
- misc: missing samples/diskimages toggle red profile status only when scanned for
- misc: updated xml definitions for forte agent reader
- misc: also loading setformat01.xml to setformat10.xml for further custom definitions
- misc: html reported is now sorted
- added: profiler->list popup 'Load Profile(s) in BatchMode' also allows a single dat
- added: profiler->tree popup 'show '<ALL PROFILES> Folder' (show all profiles at once)

clrmamepro 3.91b (27-Sep-2006)

- added: xml description file setformat.xml which lets you specify set list exports in scanner's popupmenu. Default file includes definitions for standard set list, CSV and some newsreader applications.
- added: drag'n drop in set information window can be used to enable sets
- added: batchrun: 'always use 'default.cmp' for new dat' (tri state checkbox)
- added: batchrun: 'for default naming use' options (also in profiler options)
- added: %c (cloneof) %C (sampleof) %f (setname) etc to the variable list and made it accessable from setinfo, rebuilder adv and setformat.xml
- misc: profiler and scanresults windows remember maximized state attribute
- misc: several gui/text changes
- fixed: setinfo hide-bios option doesn't hide biossets
- fixed: listinfo parser falsely trims string in quotes
- fixed: an aborted progress cancel in batchmode falsely asks to stop the batchrun
- fixed: profiler info window state isn't remembered when leaving with ESC key
- fixed: scanner [x] doesn't store window placements
- fixed: xml sax parser handles "&apos;", "&quot;", multiple escaped chars in one tag and hexadecimal escaping
- removed: removed several scanner popup menu items (set list export, csv), this is handled by the new export set list options

clrmamepro 3.91a (14-Sep-2006)

- fixed: dir2dat unzipped files gets skipped due to 3.91 fix

clrmamepro 3.91 (13-Sep-2006)

- added: scanner show statistics button
- added: profiler tree got an own popupmenu with folder specific items now
- added: profiler tree got popupmenu options to scan all dats in folders/subfolders
- misc: default values for fastscan/logfile and auto-create rompath is now based on a user selection in profiler options. You can select datfile name, name tag or folder. Folder selection is useful if you you're using a tosec datfile/profile structure.
- misc: added some missing tooltips and changed several dialogs layout
- misc: switched to NSIS for Installer
- fixed: profiler info window reappears rarely when www mode is toggled
- fixed: www profiler progress bar isn't reset when switching to next url sometimes
- fixed: batch run: auto-create rompath fails when setting a not existing root folder
- fixed: dir2dat adds baddump file to the dat when sourcefile is locked by another task
- fixed: some right-click hittest issues
- fixed: fix missing sometimes tries to fix skipped sets

clrmamepro 3.90 (28-Aug-2006)

- added: XML driven file header support. For detailed information, please consult the xmlheaders.txt file.
- misc: moved all set specific selection stuff from settings to setinfo window
- misc: renamed "?" button for set information
- misc: new apply button instead of OnKillFocus to apply regular expressions
- misc: www profiler xmls get a valid xml header
- misc: xml sax parser handles xml header and xml comments correctly
- misc: using updated zipclass library
- misc: drag'n drop operations bring windows to top position
- misc: optimized setinfo tree/list refresh
- misc: deleting a profile selects first profile in the current profile folder
- fixed: disabling name check falsely hides listed unneeded issues as well
- fixed: double entries in fixdatfiles if rom is listed several times in the scan results tree

clrmamepro 3.89b (20-Jun-2006)

- fixed: setsubfolder is broken since 3.89a
- fixed: not empty "select sets" entry isn't reassigned after datfile load

clrmamepro 3.89a (18-Jun-2006)

- fixed: searching for illegal crc32 values in setinfo (up/down arrows) crashes
- fixed: unneeded file shows zips as folders and didn't show the full path in the zip
- fixed: zip path info with drive letter caused aren't handled correctly
- added: profiler html report for currently selected folder

clrmamepro 3.89 (07-Jun-2006)

- added: zip option OEM/ANSI conversion. This enabled/disables conversion of non standard filenames in zipfiles. Keep it enabled as long as you don't use any non standard characters. Remember, conversion results depend on your currently used codepage. If you got problems renaming roms, you should toggle this option. This is a per-profile setting and enabled by default.
- misc: zip option 'mark useless zip structs as unneeded" is now a global setting
- misc: unneeded diskimages will be listed as 'diskimages' instead of file/folder
- misc: diskimage + unneeded detects unneeded diskimages even if 'roms' isn't selected (official chd storage method only)
- misc: when using sysdefpaths, chds optionally have to use the sysdefpath now, too (e.g. btchamp should be in a subfolder of the konamiGV assigned path) Added a scanner advanced option for that. Use it in combination with the warning about wrong sysdefpaths option there.
- misc: changed the layout in scanner advanced a bit
- fixed: FolderBrowser can trash memory when COM library was closed 'too early'
- fixed: some OEM/ANSI conversion can cause DOUBLE FILEENTRY IN ZIPFILE issues
- fixed: toggling fix-all toggles the tree which isn't needed
- fixed: previously loaded setselection is falsely applied to next loaded profile

clrmamepro 3.88 (24-May-2006)

- misc: switched officially to a VS2005 compile, compressed with upx2
- fixed: unneeded chds get skipped when romset is ok and chd is stored in a folder with a higher rompath index
- fixed: fix missing rom can pickup a chd rompath subfolder instead of an existing rom zipfile
- fixed: Linux/WINE UpdateTipText() functions cause window update issues
- fixed: Linux/WINE AfxMessageBox don't appear
- fixed: Linux/WINE removed some LockWindowUpdate() to prevent some warnings

clrmamepro 3.87c (11-May-2006)

- fixed: biosset detector fails when the dat assigns a set to a BIOS set and the set's biosroms are nodumps and these names differ from the ones in the assigned BIOS set (yujan/yuka effect)
- fixed: setinfo window reopens on scanner reentry when it was closed by ESC

clrmamepro 3.87b (05-May-2006)

- misc: speed increase for several fix-missing hashchecks
- misc: if "select sets" editbox is not empty, the commands in there will be reapplied on updated datfiles
- misc: setinfo window shows resizegrip
- misc: added 2 scanner drag&drop warnings for possible rebuilder destination prestring and ignore rebuiltto tags. Normally prestrings and rebuildto entries are not wanted for a scanner rebuild.
- fixed: www profiler doesn't download all files containing spaces (WINE-only issue)
- fixed: scanresults title set count doesn't match others

clrmamepro 3.87a (24-Apr-2006)

- fixed: 'file sharing problem' handles files as missing
- fixed: browse for folder didn't work very on some XP systems (very rare issue)
- fixed: adv. rebuilder's remove-only creates some not-used folders
- misc: support for chds in a pure rompath is now only optionally available. It's not officially supported in MAME anymore, so you have to keep them in rompath subfolders now....or you enable the new scanner advanced option to allow them in a rompath root.
- misc: compiled with new zipclass lib
- misc: changed some optimization compiler settings
- misc: warningswindow shows an info about "fix-missing scans all files" (when used)

clrmamepro 3.87 (07-Apr-2006)

- fixed: major bug in fixcase when working on zipfiles

clrmamepro 3.86 (04-Apr-2006)

- misc: scanner speed increase
- misc: tree gets toggled again on "expand all items"
- misc: minimize button gets removed in 1x6 view, so you can move the window
- misc: www profiler download asks you for a folder
- misc: changed 'wrong merged set' msg for fake clones
- added: scanner view popup menu set...(showsystem) (default = enabled)
- added: number of (missing) biosroms to the statistics window
- fixed: backupfolder keeps some unzipped backups
- fixed: profiler doesn't remember lastused profile when updating a dat

clrmamepro 3.85c (24-Mar-2006)

- added: systems->Move sets option which automaticall cleans up your sysdefpath sets
- misc: drawing resize grip
- misc: rebuilderadv memory option doesn't react weird for illegal inputs anymore
- misc: SetInfo, AutoScroll, StayOnTop, ShowLeading0x, ExpandAllItems settings are now global, not per profile settings
- misc: default value of ShowLeading0x changed to 'disabled'
- misc: ExpandAllItems doesn't toggle the tree anymore but acts as an on/off setting
- misc: better progress-cancel check on detecting unneeded sets
- removed: scan-results lower infobox (use "view->for listed issued.." options instead)

clrmamepro 3.85b (21-Mar-2006)

- fixed: profiler doesn't list new dats

clrmamepro 3.85a (20-Mar-2006)

- added: rebuilder advance option for a remove-only run. Although you have to specify a destination folder. Disabling the 'normal' remove-rebuilt-source option will disable that advanced option, too
- added: scanner view popup menu set...(showfolder/size/manufacturer/sampleparent/parent)
- added: scanner view popup menu rom...(show size/crc32/complemented/md5/sha1)
- added: scanner view popup menu chd...(show md5/sha1)
- removed: old profile-based 'show manufacturer' option
- removed: old profile-based 'show complemented crc' option
- misc: improved the profiler refresh speed (for all optimizations the profiles have to be rescanned though) but even without you should see a speed gain.
- misc: improved scanner speed for biosroms
- misc: changed some samplepath warnings
- misc: changed the order of the popupmenu a bit
- misc: no tree refresh when nothing important was changed in 'checksums'
- misc: optimized loading speed of scanresults a little bit
- misc: speed optimization on profiler-refresh
- misc: removed leading 0x from exported dats

clrmamepro 3.85 (03-Mar-2006)

- added: profiler option to allow/forbid merging between different systems (e.g CVS with Standard in the hunchback sets) default value is: ALLOW

clrmamepro 3.84b (02-Mar-2006)

- misc: merge tag validate test is only performed when 'parse merge tag' option is used and when the dat actually has merge tags
- misc: merge tag validate test works on parents (with possible merge tag pointing to biosfiles) and clones (with possible merge tag pointint to biosfiles and parent romfiles)
- fixed: merge tag validate test doesn't work correctly
- fixed: 'No to all' does not work on 'wrong named resource roms'

clrmamepro 3.84a (01-Mar-2006)

- misc: fake-clones handling: changed chd storing behaviour again, keep them in a pure rompath or in a clone-subfolder
- misc: additional parsing checks if the 'merge tags' are valid
- misc: replaced parsing msgboxes with 'yes/yes2all/...' boxes
- misc: replaced parsing msgboxes with 'ok/ok2all/...' boxes
- misc: no prompt of "set default backuppath" in batchmode
- fixed: not all fake clones were detected
- fixed: systems window gets resized to old size on button usage

clrmamepro 3.84 (25-Feb-2006)

- added: profiler option: 'parse merge tags' (default = off) Enabling this will add support for 'merge' in datfiles. This is generally some additional merging information, commonly used to ignore identical files within a parent/clone relationship with different names. When you enable this option and scan sets which were scanned without that option in the past, you run into some wrong name / unneeded file (move to parent) messages. That's normal (since that's exactly what the merge tags were made for) and if you enable the fix options, they get fixed.
- added: profiler option 'don't create dummy clones' (default = on) Enabling this option will allow clrmamepro to split-merge fake clones (100% identical sets within a parent/clone relationship). In other words they will be fully merged into the parent. Toggling these new options will clean the profiler cache, too.
- misc: little merger speed increase
- misc: using latest zipclass library

clrmamero 3.83c (19-Jan-2006)

- fixed: biosset assignment routine didn't handle some clone sets correctly

clrmamero 3.83b (18-Jan-2006)

- misc: removed scanner checkbox-bindings (missing + name check / unneeded check + name check) so you can toggle each checkbox now independly. For unsafe scans you'll see a warning.
- fixed: several 64bit rom-filesize issues (including scanner, rebuilder, setinfo, dir2dat)
- fixed: datfile forcezip tags didn't apply to the rebuilder when called through the scanner

clrmamero 3.83a (13-Jan-2006)

- misc: switched back to VS2003 but fixed some exceptions which were discovered in VS2005

clrmamero 3.83 (12-Jan-2006)

- misc: first compile with VS2005, let me know if you got any problems (esp. on older OSes, 64bit processors etc...etc...)
- misc: some more free memory after building checksum tables
- fixed: warning window's 'move all' didn't work correctly
- fixed: biosset assignment routine didn't handle sets correctly which include biosroms but don't use the biosset (kof2003/MAME .103u2)

clrmamero 3.82a (31-Dec-2005)

- fixed: cmpro.ini AutoWWWUpdate & DownloadPrompt options aren't loaded correctly

clrmamero 3.82 (23-Dec-2005)

- fixed: byteswap fixing routine in scanner's checksum analysis functions
- fixed: circular rename of chd files in MAME .102u5

clrmamero 3.81c (28-Nov-2005)

- fixed: batchrun, some editboxes are cleared when toggling some checkboxes
- fixed: exe/datfile type both gets enabled after returning from www profiler
- fixed: remembering of last used profile when canceling the profiler
- misc: enabled maximize button for profiler
- misc: moved dir2dat to profiler

clrmamero 3.81b (22-Nov-2005)

- misc: some compile tests with VS2005. Cleaned up the sourcecode, so it will compile with 0 errors/0 warnings under VS2005, although this build is still compiled with VS2003. Updated code includes some C++ bugfixes, lots of future deprecated functions replacements, etc...most likely the last compile for VS2003 and this year.
- added: profiler->edit datfile, opens the selected datfile with the assigned editor
- added: www profiler does an auto-refreshes on each entry. You can disable this behaviour in the profiler options.
- fixed: progress bar for www profiler xml files doesn't get reset after update
- misc: some menu text changes

clrmamero 3.81a (07-Nov-2005)

- misc: used updated zipclass library
- misc: using xml's build attribut as exe-based version tag
- misc: showing version column in profiler
- misc: html report lists full path of the datfilefolders
- fixed: rebuilding not-separated biosroms shows biosset name as rebuilt

clrmamero 3.81 (18-Oct-2005)

- misc: www profiler red-* icon for sites *only* appears when at least one file of the site is new / was updated
- misc: little speed optimization for chd detection in unneeded rom tests
- fixed: several old browse-folder settings aren't remembered correctly
- fixed: some issues while loading wwwdats.ini/urls.ini
- fixed: wwwprofiler doesn't display empty sites

clrmamero 3.80c (10-Oct-2005)

- misc: you can access the scanresults window even when the stats are shown
- misc: renamed "removed rebuilt sourcefiles" to "remove matched sourcefiles"
- misc: also bad checksums and wrong sized roms will mark a profile 'red' (although you have to rescan the profiles once to get that activated)
- fixed: wwwprofiler status isn't determined correctly in all cases
- fixed: wwwprofiler doesn't refresh 'new/not used dats' when leaving via ESC or [X]

clrmamepro 3.80b (30-Sep-2005)

- misc: replaced some copy/delete- with movefile (only some backup options are effected)
- misc: backup filename randomizer preserves fileextension
- fixed: some unzipped sets merger issue
- fixed: rare crash when toggling www mode

clrmamepro 3.80a (26-Sep-2005)

- misc: you can't download local datfiles anymore
- fixed: windows 2000 tree control refresh issue
- fixed: horiz. scrollbar hides last scanresults tree item in some cases

clrmamepro 3.80 (23-Sep-2005)

- Sick of searching new datfiles? Not knowing which are up2date? Tired of visiting dozens of www sites to get new dats? Don't know how many new dats which don't have yet are out there....well....that's over.... Happily introduce to you: The WWW PROFILER
- For more information read the wwwprofiler.txt file.
  Some further stuff:
- added: save set-list options added as copy to clipboard options too
- added: delete options added as move (to a selectable folder) options too
- added: rebuilder adv. lets you set the cache size for no-recompress rebuilds (8-128MB)
- misc: optimized rebuilder's additional sha1/md5 checks
- misc: profiler window and progresswindow shows correct icon ;)
- misc: better remebering of last used profile
- misc: readded some custom treecontrol functions (speeding up tree)
- misc: rebuilder log gives some more detailed information for 'skip' events
- misc: don't show number of received bytes anymore when importing data (reporting the size fluently could be the cause for some broken imports)
- fixed: some rare exception in the 3rd party zipclass library
- fixed: nodump handling controls can get enabled for some non-nodump dats
- fixed: pressing progress window cancel in batchrun mode doesn't let you stop
- the batchrun optionally as well in all cases
- fixed: since the zipscanner detects zips by structures and not by fileextension .zip
- it may run into trouble with file which are renamed zips.

clrmamepro 3.73 (25-Aug-2005)

- added: warnings window to dir2dat
- added: scanner stats list "missing bytes"
- added: scanner popupmenu->drag'n drop->rebuilder show statistics
- added: some not very well hidden little easter egg 8)
- fixed: dir2dat doesn't add files when unzipping failed
- fixed: warningswindow lists set-subfolderfiles with wrong slash
- removed: some very old unneeded core stuff
- misc: improved dir2dat speed
- misc: profiler tree for moving/adding will autoselect current folder
- misc: revised tree items selection with left/right click combinations
- misc: readded some improvements which were removed from 3.71d to 3.72
- misc: minor gui changes

clrmamepro 3.72 (11-Aug-2005)

- added: batcher: 'use fastscan if possible'
- misc: scanner: 'delete all incomplete' includes wrong-sized roms
- misc: core: some minor text changes
- misc: core: optimizations/fixes/changes to 'cleaning up data'
- misc: profiler: overwriting datfiles resets profile to 'not scanned yet'
- removed: dir2dat: rebuildto options. Use setsubfolder mode instead.
- fixed: dir2dat: singleset/setsubfolder combined drops a name subfolder
- fixed: profile Setting_Sets entries is changed by 'move profile'
- fixed: scanner: random name for existing files backup isn't random ;)
- fixed: scanner: nodump handling options get enabled (leaving scanner adv.)
- fixed: several 'biosset' tag issues (just tag specific, not set specific)

clrmamepro 3.71c (03-Aug-2005)

- fixed: backup doesn't remove a temporary backupfolder when > 1 files were used in the current backup operation

clrmamepro 3.71b (02-Aug-2005)

- misc: dir2dat cuts off only .zip extensions for setname/setdescription
- misc: no more profiler list refresh after 'copy profile name' & 'html report'
- misc: 'counting files' progress windows shows the current folder as well
- misc: 'copy profile name' copies all selected profilenames
- misc: using new name for backup'ed files if name already exists
- added: batchrun: auto create rompath when loading new dats
- fixed: if backup fails on '_unknown' folder, this backupsubfolder is removed
- fixed: hidden warningswindow is shown after min/max progresswindow

clrmamepro 3.71a (25-Jul-2005)

- misc: compiled with updated zipclass library (incl. zlib 1.2.3)
- misc: rebuilder log shows '[exists]' for already existing destination files
- misc: showing progress info when couting files
- misc: don't allow moving of not used/new datfiles anymore
- misc: don't allow renaming of not used/new datfiles & profile in use anymore
- misc: don't allow renaming of profiles with romcenter or xml based datfiles
- misc: changed several profiler texts
- misc: old kept scan results won't be loaded this time due to format changes. They will be replaced directly with the new format after a scan though
- fixed: scanner: fixdatfile lists wrong entries
- fixed: profiler: renaming profile without datfile header, kills the datfile

clrmamepro 3.71 (21-Jul-2005)

- misc: revised rebuilder: showing a different text when removing rebuilt files
- misc: revised scanner: fixing prompts will appear as topmost window
- misc: rebuilder: increased rebuilder speed dramatically (for huge zips)
- misc: rebuilder: increased remove-rebuilt-source speed (for files in zipfiles)
- misc: rebuilder: showing a different text when removing rebuilt files
- misc: profiler: html report doesn't include empty folders
- misc: scanner: fixing prompts will appear as topmost window
- misc: scanner: skipping some more information prompts in batchrun mode
- fixed: moving a currently loaded profile could leave some settings file in the wrong folder and it got some sideeffect on the displayed tree
- fixed: profiler: tree shows "+" when empty child folders are hidden
- fixed: animation area collides with % progress text
- fixed: progress window gets a bit messy when resizing...
- fixed: rare progress window crash when reading xml dats
- fixed: hiding treebranches (red/green/grey hiding) doesn't work in all cases

clrmamepro 3.70 (14-Jul-2005)

- misc: fixdats: rewrote generation routine (much faster now)
- misc: fixdats: changed the way fixdatfile saving works:
  As long as you use auto-save-fixdatfile, they will be stored in cmpro's
  fixdatfolder, using a profiler-related subfolder scheme.
  Any popupmenu->save fixdatfile option will always show a prompt for a
  destination file. You won't be asked for the datheader name anymore.
  Autofixdats will be updated/deleted/moved/etc when the belonging
  profiler option is used.
- misc: profiler: you can directly select a datfile subfolder when adding dats
- misc: profiler: profiler tree selector (the move/add one) fully expands tree
- misc: profiler: empty folders after 'hide green/red/grey' aren't shown
- misc: profiler: moved settings->'datfile errors' to profiler options
- misc: profiler: zipfile datpicker got a header control now
- misc: core: datfiles can have zero rom sizes (is handled as a nodump)
- misc: gui: saving mainwindow position
- misc: gui: replaced animation (big thanks to Nicole Schmitz for providing it)
- misc: gui: countless menu/text/gui/etc changes
- misc: gui: centering window when no/illegal pos was saved (instead of 0/0)
- misc: batchrun: no 'no rom/samplepath warning' prompt in batchmode
- added: batchrun: 'always use default' option
- added: profiler: popup menu: copy datfilename to clipboard
- fixed: profiler: drag&drop folders with datfiles/more subfolders doesn't pickup files from subfolders.
- fixed: profiler: zipfile datpicker doesn't import zip's subfolder structure
- fixed: profiler: a lot of garbage collection issues
- fixed: core: zlib buffer overflow issue
- fixed: about: drag&drop shows hashes for 0-sized bytes
- removed: profiler: "default settings created successfully" prompt

3.61 (28-Jan-2005) - 3.67b (07-Jul-2005)
3.50 (24-Nov-2004) - 3.60 (26-Jan-2005)
3.30 (15-Apr-2004) - 3.45a (14-Nov-2004)
3.22 (13-Jan-2004) - 3.25a (08-Apr-2004)
3.10 (12/04/2003) - 3.21 (01/08/2004)
3.08a (11/19/2003) - Version 3.00 (05/23/03)

Version 2.90 (05/15/03)
- Version 2.01 (05/04/2001)
- Version 1.94 (03/22/2001)
- Version 1.00 (01/20/2000)
- Beta and RC phase: 08/29/99 - 01/05/00